#include "five.h"

int board[20][20];
int pcapturecount = 0, ccapturecount = 0;

int main( void )
{
  int won = NO_VALUE;

  while( 1 ) {
    Initialize();
    while( 1 ) {
      if ( ( ( won = Playersturn() ) != NO_VALUE ) || ( ( won = Computersturn() ) != NO_VALUE ) ) {
        break;
      }
    }
    Displayboard();
    if ( won == COMPUTER_WINS ) {
      printf( "The computer wins!\n\n" );
    }
    else {
      printf( "You win!\n\n" );
    }
    printf( "Do you want to play again?" );
    if ( toupper( getchar() ) == 'N' ) {
      break;
    }
    else {
      getchar();
    }
  }
}

void Initialize( void )
{
  register int i, j;
  for ( i = 0; i < 20; i++ ) {
    for ( j = 0; j < 20; j++ ) {
      board[i][j] = NO_VALUE;
    }
  }
  pcapturecount = ccapturecount = 0;
}

int Playersturn( void )
{
  char row[4], column[4], *endptr;
  long int a = NO_VALUE, b = NO_VALUE;

  while( 1 ) {
    Displayboard();
    printf( "Enter row: " );
    fgets( row, 4, stdin );
    printf( "\nEnter column: " );
    fgets( column, 4, stdin );
    putchar( '\n' );
    a = strtol( row, &endptr, 10 );
    if ( *endptr != '\n' ) {
      printf( "That's not a valid board position\n" );
      sleep(1000);
      continue;
    }
    b = strtol( column, &endptr, 10 );
    if ( (a < 0) || (a > 19) || (b < 0) || (b > 19) || (*endptr != '\n') ) {
      printf( "That's not a valid board position\n" );
      sleep(1000);
      continue;
    }
    if ( board[a][b] != NO_VALUE ) {
      printf( "A piece is already on that square.\n" );
      sleep(1000);
      continue;
    }
    break;
  }
  board[a][b] = PLAYER_PIECE;
  Capturecheck( (int) a, (int) b, PLAYER_PIECE );
  if ( pcapturecount >= 5 ) {
    return PLAYER_WINS;
  }
  return( Playerwon(a, b) ); 
}

int Computersturn( void )
{
  int i, j, value = NO_VALUE, best = NO_VALUE, besti = NO_VALUE, bestj = NO_VALUE;
 
  for ( i = 0; i < 20; i++ ) {
    for ( j = 0; j < 20; j++ ) {
      if ( ( value = Positionvalue( i, j ) ) > best ) {
        best = value;
        besti = i;
        bestj = j;
        if ( value == COMPUTER_WON ) {
          break;
        }
      }
    }
    if ( value == COMPUTER_WON ) {
      break;
    }
  }
  srand(time(NULL));
  while( besti == NO_VALUE ) {  
    besti = (int) ( 20.0 * rand() / ( RAND_MAX + 1.0 ) );
    bestj = (int) ( 20.0 * rand() / ( RAND_MAX + 1.0 ) );
    if ( board[besti][bestj] != NO_VALUE ) {
      besti = NO_VALUE;
      continue;
    }
  }
  board[besti][bestj] = COMPUTER_PIECE;
  Capturecheck( besti, bestj, COMPUTER_PIECE );
  if ( ccapturecount >= 5 ) {
    return COMPUTER_WINS;
  }
  if ( best == COMPUTER_WON ) {
    return COMPUTER_WINS;
  }
  return NO_VALUE;
}

void Displayboard( void )
{
  register int i, j;

  printf( "\n\n  | 0| 1| 2| 3| 4| 5| 6| 7| 8| 9|10|11|12|13|14|15|16|17|18|19|\n");
  for ( i = 0; i < 20; i++ ) {
    if ( i < 10 ) {
      printf( " %d|", i );
    }
    else {
      printf( "%d|", i );
    }
    for ( j = 0; j < 20; j++ ) {
      if ( board[i][j] == NO_VALUE ) {
        printf( "  |" );
      }
      else if ( board[i][j] == PLAYER_PIECE ) {
        printf( " X|" );
      }
      else {
        printf( " O|" );
      }
    }
    putchar( '\n' );
  }
  putchar( '\n' );
}

int Playerwon( long int a, long int b )
{ 
  int i, j, playercount = 1;

  /* Check northwest and southeast */
  i = a - 1;
  j = b - 1; 
  while ( ( i > -1 ) && ( j > -1 )  && ( board[i][j] == PLAYER_PIECE ) ) {
    playercount++;
    i--;
    j--;
  }
  i = a + 1;
  j = b + 1;
  while ( ( i < 20 ) && ( j < 20 ) && ( board[i][j] == PLAYER_PIECE ) ) {
    playercount++;
    i++;
    j++;
  }
  if ( playercount >= 5 ) {
    return PLAYER_WINS;
  }
  /* Check north and south */
  playercount = 1;
  i = a - 1;
  j = b;
  while ( ( i > -1 ) && ( board[i][j] == PLAYER_PIECE ) ) {
    playercount++;
    i--;
  }
  i = a + 1;
  j = b;
  while ( ( i < 20 ) && ( board[i][j] == PLAYER_PIECE ) ) {
    playercount++;
    i++;
  }
  if ( playercount >= 5 ) {
    return PLAYER_WINS;
  }
  /* Check northeast and southwest */
  playercount = 1;
  i = a - 1;
  j = b + 1;
  while ( ( i > -1 ) && ( j < 20 ) && ( board[i][j] == PLAYER_PIECE ) ) {
    playercount++;
    i--;
    j++;
  }
  i = a + 1;
  j = b - 1;
  while ( ( i < 20 ) && ( j > -1 ) && ( board[i][j] == PLAYER_PIECE ) ) {
    playercount++;
    i++;
    j--;
  }
  if ( playercount >= 5 ) {
    return PLAYER_WINS;
  }
  /* Check east and west */
  playercount = 1;
  i = a;
  j = b + 1;
  while ( ( j < 20 ) && ( board[i][j] == PLAYER_PIECE ) ) {
    playercount++;
    j++;
  }
  i = a;
  j = b - 1;
  while ( ( j > -1 ) && ( board[i][j] == PLAYER_PIECE ) ) {
    playercount++;
    j--;
  }
  if ( playercount >= 5 ) {
    return PLAYER_WINS;
  }
  return NO_VALUE;
}

void Capturecheck( int i, int j, int who )
{
  /* Check northwest */
  if ( ( i > 2 ) && ( j > 2 ) && ( board[i-1][j-1] == !who ) && ( board[i-2][j-2] == !who ) && ( board[i-3][j-3] == who ) ) {
    board[i-1][j-1] = board[i-2][j-2] = NO_VALUE;
    Incrementcapture( who );
  }
  /* Check north */
  if ( ( i > 2 ) && ( board[i-1][j] == !who ) && ( board[i-2][j] == !who ) && ( board[i-3][j] == who ) ) {
    board[i-1][j] = board[i-2][j] = NO_VALUE;
    Incrementcapture( who );
  }
  /* Check northeast */
  if ( ( i > 2 ) && ( j < 17 ) && ( board[i-1][j+1] == !who ) && ( board[i-2][j+2] == !who ) && ( board[i-3][j+3] == who ) ) {
    board[i-1][j+1] = board[i-2][j+2] = NO_VALUE;
    Incrementcapture( who );
  }
  /* Check east */
  if ( ( j < 17 ) && ( board[i][j+1] == !who ) && ( board[i][j+2] == !who ) && ( board[i][j+3] == who ) ) {
    board[i][j+1] = board[i][j+2] = NO_VALUE;
    Incrementcapture( who );
  }
  /* Check southeast */
  if ( ( i < 17 ) && ( j < 17 ) && ( board[i+1][j+1] == !who ) && ( board[i+2][j+2] == !who ) && ( board[i+3][j+3] == who ) ) {
    board[i+1][j+1] = board[i+2][j+2] = NO_VALUE;
    Incrementcapture( who );
  }
  /* Check south */
  if ( ( i < 17 ) && ( board[i+1][j] == !who ) && ( board[i+2][j] == !who ) && ( board[i+3][j] == who ) ) {
    board[i+1][j] = board[i+2][j] = NO_VALUE;
    Incrementcapture( who );
  }
  /* Check southwest */
  if ( ( i < 17 ) && ( j > 2 ) && ( board[i+1][j-1] == !who ) && ( board[i+2][j-2] == !who ) && ( board[i+3][j-3] == who ) ) {
    board[i+1][j-1] = board[i+2][j-2] = NO_VALUE;
    Incrementcapture( who );
  }
  /* Check west */
  if ( ( j > 2 ) && ( board[i][j-1] == !who ) && ( board[i][j-2] == !who ) && ( board[i][j-3] == who ) ) {
    board[i][j-1] = board[i][j-2] = NO_VALUE;
    Incrementcapture( who );
  }
}

void Incrementcapture( int who )
{
  if ( who == PLAYER_PIECE ) {
    pcapturecount++;
  }
  else {
    ccapturecount++;
  }
}

int Positionvalue( int i, int j )
{
  int computercount = 0, playercount = 0, rowtemp = i - 1, columntemp = j - 1;
  int typecheck = NO_VALUE, open = TRUE, split = TRUE;
  int value = NO_VALUE, bestvalue = NO_VALUE, opentemp;

  if ( board[i][j] != NO_VALUE ) {
    return NO_VALUE;
  }
  if ( ( rowtemp > -1 ) && ( columntemp > -1 ) ) {
    typecheck = board[rowtemp][columntemp];
  }
  while ( ( rowtemp > -1 ) && ( columntemp > -1 ) && ( board[rowtemp][columntemp] != NO_VALUE ) && open ) {  /* count pieces to the northwest */
    Checkline( NORTHWEST, typecheck, &playercount, &computercount, &open, &rowtemp, &columntemp );
  }
  if ( ( rowtemp == -1 ) || ( columntemp == -1 ) ) {
    open = FALSE;
  }
  rowtemp = i + 1;
  columntemp = j + 1;
  if ( ( typecheck != NO_VALUE ) && ( rowtemp < 20 ) && ( columntemp < 20 ) && ( board[rowtemp][columntemp] == typecheck ) ) {
    split = TRUE;
  }
  else {
    split = FALSE;
    if ( ( rowtemp < 20 ) && ( columntemp < 20 ) && ( typecheck == NO_VALUE ) ) {
      typecheck = board[rowtemp][columntemp];
    }
  }
  opentemp = open;
  open = TRUE;
  while ( ( rowtemp < 20 ) && ( columntemp < 20 ) && ( board[rowtemp][columntemp] != NO_VALUE ) && open ) {  /* count pieces to the southeast */
    Checkline( SOUTHEAST, typecheck, &playercount, &computercount, &open, &rowtemp, &columntemp );
  }
  if ( ( rowtemp == 20 ) || ( columntemp == 20 ) ) {
    open = FALSE;
  }
  if ( !opentemp ) {
    open = opentemp;
  }
  bestvalue = Linevalue( split, open, typecheck, computercount, playercount );
  /* Now I'm going to look north and south */
  open = TRUE;
  rowtemp = i - 1;
  columntemp = j;
  playercount = 0;
  computercount = 0;
  typecheck = NO_VALUE;
  if ( rowtemp > -1 ) {
    typecheck = board[rowtemp][columntemp];
  }
  while ( ( rowtemp > -1 ) && ( board[rowtemp][columntemp] != NO_VALUE ) && open ) {  /* count pieces to the north */
    Checkline( NORTH, typecheck, &playercount, &computercount, &open, &rowtemp, &columntemp );
  }
  if ( rowtemp == -1 ) {
    open = FALSE;
  }
  rowtemp = i + 1;
  if (  ( typecheck != NO_VALUE ) && ( rowtemp < 20 ) && ( board[rowtemp][columntemp] == typecheck ) ) {
    split = TRUE;
  }
  else {
    split = FALSE;
    if ( ( rowtemp < 20 ) && ( typecheck == NO_VALUE ) ) {
      typecheck = board[rowtemp][columntemp];
    }
  }
  opentemp = open;
  open = TRUE;
  while ( ( rowtemp < 20 ) && ( board[rowtemp][columntemp] != NO_VALUE ) && open ) {  /* count pieces to the south */
    Checkline( SOUTH, typecheck, &playercount, &computercount, &open, &rowtemp, &columntemp );
  }
  if ( rowtemp == 20 ) {
    open = FALSE;
  }
  if ( !opentemp ) {
    open = opentemp;
  }
  if ( ( value = Linevalue( split, open, typecheck, computercount, playercount ) ) > bestvalue ) {
    bestvalue = value;
  }
/* Now I'm going to look northeast and southwest */ 
  open = TRUE;
  rowtemp = i - 1;
  columntemp = j + 1;
  playercount = 0;
  computercount = 0;
  typecheck = NO_VALUE;
  if ( ( rowtemp > -1 ) && ( columntemp < 20 ) ) {
    typecheck = board[rowtemp][columntemp];
  }
  while ( ( rowtemp > -1 ) && ( columntemp < 20 ) && ( board[rowtemp][columntemp] != NO_VALUE ) && open ) {  /* count pieces to the northeast */
    Checkline( NORTHEAST, typecheck, &playercount, &computercount, &open, &rowtemp, &columntemp );
  }
  if ( ( rowtemp == -1 ) || ( columntemp == 20 ) ) {
    open = FALSE;
  }
  rowtemp = i + 1;
  columntemp = j - 1;
  if ( ( typecheck != NO_VALUE ) && ( rowtemp < 20 ) && ( columntemp > -1 ) && ( board[rowtemp][columntemp] == typecheck ) ) {
    split = TRUE;
  }
  else {
    split = FALSE;
    if ( ( rowtemp < 20 ) && ( columntemp > -1 ) && ( typecheck == NO_VALUE ) ) {
      typecheck = board[rowtemp][columntemp];
    } 
  }
  opentemp = open;
  open = TRUE;
  while ( ( rowtemp < 20 ) && ( columntemp > -1 ) && ( board[rowtemp][columntemp] != NO_VALUE ) && open ) {  /* count pieces to the southwest */
    Checkline( SOUTHWEST, typecheck, &playercount, &computercount, &open, &rowtemp, &columntemp );
  }
  if ( ( rowtemp == 20 ) || ( columntemp == -1 ) ) {
    open = FALSE;
  }
  if ( !opentemp ) {
    open = opentemp;
  }
  if ( ( value = Linevalue( split, open, typecheck, computercount, playercount ) ) > bestvalue ) {
    bestvalue = value;
  }
/* Now I'm going to count pieces to the east and west */
  open = TRUE;
  rowtemp = i;
  columntemp = j + 1;
  playercount = 0;
  computercount = 0;
  typecheck = NO_VALUE;
  if ( columntemp < 20 ) {
    typecheck = board[rowtemp][columntemp];
  }
  while ( ( columntemp < 20 ) && ( board[rowtemp][columntemp] != NO_VALUE ) && open ) {  /* count pieces to the east */
    Checkline( EAST, typecheck, &playercount, &computercount, &open, &rowtemp, &columntemp );
  }
  if ( columntemp == 20 ) {
    open = FALSE;
  }
  columntemp = j - 1;
  if ( ( typecheck != NO_VALUE ) && ( columntemp > -1 ) && ( board[rowtemp][columntemp] == typecheck ) ) {
    split = TRUE;
  }
  else {
    split = FALSE;
    if ( ( columntemp > -1 ) && ( typecheck == NO_VALUE ) ) {
      typecheck = board[rowtemp][columntemp];
    }
  }
  opentemp = open;
  open = TRUE;
  while ( ( columntemp > -1 ) && ( board[rowtemp][columntemp] != NO_VALUE ) && open ) {  /* count pieces to the west */
    Checkline( WEST, typecheck, &playercount, &computercount, &open, &rowtemp, &columntemp );
  }
  if ( columntemp == -1 ) {
    open = FALSE;
  }
  if ( !opentemp ) {
    open = opentemp;
  }
  if ( ( value = Linevalue( split, open, typecheck, computercount, playercount ) ) > bestvalue ) {
    bestvalue = value;
  }
  return bestvalue;
}

void Checkline( int direction, int typecheck, int *pplayercount, int *pcomputercount, int *openp, int *prowtemp, int *pcolumntemp )
{ 
  if ( board[*prowtemp][*pcolumntemp] == COMPUTER_PIECE ) {
    if ( typecheck == COMPUTER_PIECE ) {
      (*pcomputercount)++;
    }
    else {
      *openp = FALSE;
    }
  }
  else {
    if ( typecheck == PLAYER_PIECE ) {
      (*pplayercount)++;
    }
    else {
      *openp = FALSE;
    }
  }
  switch( direction ) {
    case NORTHWEST:
      (*prowtemp)--;
      (*pcolumntemp)--;
      break;
    case NORTH:
      (*prowtemp)--;
      break;
    case NORTHEAST:
      (*prowtemp)--;
      (*pcolumntemp)++;
      break;
    case EAST:
      (*pcolumntemp)++;
      break;
    case SOUTHEAST:
      (*prowtemp)++;
      (*pcolumntemp)++;
      break;
    case SOUTH:
      (*prowtemp)++;
      break;
    case SOUTHWEST: 
      (*prowtemp)++;
      (*pcolumntemp)--;
      break;
    case WEST: 
      (*pcolumntemp)--;
      break;
  }
}

int Linevalue( int split, int open, int typecheck, int computercount, int playercount ) 
{
  int value = NO_VALUE;

  if ( typecheck == NO_VALUE ) {
    return NO_VALUE;
  }
  if ( split ) {
    if ( typecheck == COMPUTER_PIECE ) {
      switch( computercount ) {
        case 2:
          value = FILL_SPLIT_TWO;
          break;
        case 3:
          value = FILL_SPLIT_THREE;
          break;
        default:
          return COMPUTER_WON;
      }
    }
    else {
      switch( playercount ) {
        case 2:
          value = BLOCK_SPLIT_TWO;
          break;
        case 3:
          value = BLOCK_SPLIT_THREE;
          break;
        default:
          value = BLOCK_SPLIT_FOUR;
      }
    }
  }
  else {
    if ( open ) {
      if ( typecheck == COMPUTER_PIECE ) {
        switch( computercount ) {
          case 1:
            value = EXTEND_OPEN_ONE;
            break;
          case 2:
            value = EXTEND_OPEN_TWO;
            break;
          case 3:
            value = EXTEND_OPEN_THREE;
            break;
          default:
            return COMPUTER_WON;
        }
      }
      else {
        switch( playercount ) {
          case 1:
            value = NO_VALUE;
            break;
          case 2:
            value = BLOCK_OPEN_TWO;
            break;
          case 3:
            value = BLOCK_OPEN_THREE;
            break;
          default:
            value = BLOCK_OPEN_FOUR;
        }
      }
    }
    else { 
      if ( typecheck == COMPUTER_PIECE ) {
        switch( computercount ) {
          case 1:
            value = NO_VALUE;
            break;
          case 2:
            value = EXTEND_CLOSED_TWO;
            break;
          case 3:
            value = EXTEND_CLOSED_THREE;
            break;
          default:
            return COMPUTER_WON;
        }
      }
      else {
        switch( playercount ) {
          case 1:
            value = NO_VALUE;
            break;
          case 2:
            value = CAPTURE_TWO;
            break;
          case 3:
            value = BLOCK_CLOSED_THREE;
            break;
          default:
            value = BLOCK_CLOSED_FOUR;
        }
      }
    }
  }
  return value;
}

void sleep( clock_t period )
{
  clock_t finish;

  finish = period + clock();
  while ( finish > clock() );
}
  
